program Console;
{$APPTYPE CONSOLE}
uses
  Windows,
  Classes,
  SysUtils,
  Snoop;

type
  TMySnoop = class(TSnoopTCPData)
  public
    Count: Integer;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    class function IsNormalChar(ch: Char): Boolean;
    procedure CaptureTCPData(
      Sender: TObject;
      PacketHdr: PPCAP_PKTHDR;
      ETHHdr: PETH_HDR;
      IPHdr: PIP_HDR;
      TCPHdr: PTCP_HDR;
      TCPData: PChar;
      TCPDataLen: Integer);
  end;

constructor TMySnoop.Create(AOwner: TComponent);
begin
  inherited;
  Count := 0;
  OnCaptureTCPData := CaptureTCPData;
end;

destructor TMySnoop.Destroy;
begin
  inherited;
end;

class function TMySnoop.IsNormalChar(ch: Char): Boolean;
begin
  Result := false;
  if (Ord(ch) >= 32) and (Ord(ch) <= 192) then
    Result := true;
end;

procedure TMySnoop.CaptureTCPData(
  Sender: TObject;
  PacketHdr: PPCAP_PKTHDR;
  ETHHdr: PETH_HDR;
  IPHdr: PIP_HDR;
  TCPHdr: PTCP_HDR;
  TCPData: PChar;
  TCPDataLen: Integer);
var
  i: Integer;
  s: String;
begin
  s := '';
  for i := 0 to TCPDataLen - 1 do
  begin
    if IsNormalChar(TCPData^) then
      s := s + TCPData^;
    inc(TCPData);
  end;
  WriteLn(s);
  inc(Count);
end;

function GetAdapterIndex(Snoop: TMySnoop): Integer;
var
  i, nRes: Integer;
begin
  for i := 0 to Snoop.AdapterNames.Count - 1 do
    WriteLn(i, ': ', Snoop.AdapterNames[i]);
  Write('select device: ');
  Read(nRes);
  Result := nRes;
end;

const
  DETECT_TIME = 10000;
var
  MySnoop: TMySnoop;
begin
  MySnoop := TMySnoop.Create(nil);
  MySnoop.AdapterIndex := GetAdapterIndex(MySnoop);
  MySnoop.ThreadSafe := false;
  MySnoop.Open;
  if not MySnoop.Active then
  begin
    WriteLn(MySnoop.Error);
    exit;
  end;
  Sleep(DETECT_TIME);
  MySnoop.Close;
  WriteLn(#13#10, MySnoop.Count, ' packet(s) captured during ', DETECT_TIME, ' millisecond.');
  MySnoop.Free;
end.
