unit Common;

interface

uses
  Windows, ComCtrls, IniFiles, SysUtils, Forms, WinSock,
  Snoop, SnoopMemory, SnoopTCPOption;

const
  HDR_FIELD = 1;
  ETH_FIELD = 2;
  IP_FIELD = 3;
  ARP_FIELD = 4;
  ICMP_FIELD = 5;
  TCP_FIELD = 6;
  UDP_FIELD = 7;
  TCPDATA_FIELD = 8;
  UDPDATA_FIELD = 9;

procedure AddListViewField(ListView: TListView; ListViewField: Integer; AddField: Integer);
procedure LoadListColumnWidth(Form: TForm; IniFileName: String);
procedure SaveListColumnWidth(Form: TForm; IniFileName: String);
procedure ShowColumn(ListView: TListView; StartIndex: Integer; EndIndex: Integer);
procedure HideColumn(ListView: TListView; StartIndex: Integer; EndIndex: Integer);

// procedure AddPKTHdr(ListItem: TListItem; PKTHdr: PPCAP_PKTHDR); // gilgil temp 2008.01.28
procedure AddPKTHdr(ListItem: TListItem; SnoopMemoryNode: PSnoopMemoryNode);
procedure AddETH(ListItem: TListItem; ETHHdr: PETH_HDR);
procedure AddIP(ListItem: TListItem; IPHdr: PIP_HDR);
procedure AddARP(ListItem: TListItem; ARPHdr: PARP_HDR);
procedure AddICMP(ListItem: TListItem; ICMPHdr: PICMP_HDR);
procedure AddTCP(ListItem: TListItem; IPHdr: PIP_HDR; TCPHdr: PTCP_HDR);
procedure AddUDP(ListItem: TListItem; IPHdr: PIP_HDR; UDPHdr: PUDP_HDR);
procedure AddTCPData(ListItem: TListItem; TCPData: PChar; TCPDataLen: Integer; Offset: Integer);
procedure AddUDPData(ListItem: TListItem; UDPData: PChar; UDPDataLen: Integer; Offset: Integer);

function Rsvd_Flags2Str(Flag: UCHAR): String;

implementation

procedure AddListViewField(ListView: TListView; ListViewField: Integer; AddField: Integer);
var
  ListColumn: TListColumn;
begin
  case AddField of
    HDR_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Index';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Time';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
      if (ListViewField = TCPDATA_FIELD) or (ListViewField = UDPDATA_FIELD) then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Capture';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if (ListViewField = TCPDATA_FIELD) or (ListViewField = UDPDATA_FIELD) then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Len';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if (ListViewField = TCPDATA_FIELD) or (ListViewField = UDPDATA_FIELD) then
        ListColumn.Width := 0;
    end;
    ETH_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'DstMac';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
      if ListViewField <> ETH_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'SrcMac';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
      if ListViewField <> ETH_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Protocol(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> ETH_FIELD then
        ListColumn.Width := 0;
    end;
    IP_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'VerLen(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Service';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Len';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Ident';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'FlagOff(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'TimeLive';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Protocol(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Checksum(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> IP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'SrcIP';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'DstIP';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
    end;
    ARP_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'HardwareType';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'ProtocolType';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'HLen';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'PLen';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Operation';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'SenderHA';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'SenderIP';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'TargetHA';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'TargetIP';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
    end;
    ICMP_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Type';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Code';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Checksum(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Data';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
    end;
    TCP_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Src Port';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Dst Port';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Seq(x)';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Ack(x)';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Off_Rsvd(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Rsvd_Flags(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Window';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Checksum(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'UrgPoint';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'TCPOption';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
      if ListViewField <> TCP_FIELD then
        ListColumn.Width := 0;
    end;
    UDP_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Src Port';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Dst Port';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Len';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> UDP_FIELD then
        ListColumn.Width := 0;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Checksum(x)';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
      if ListViewField <> UDP_FIELD then
        ListColumn.Width := 0;
    end;
    TCPDATA_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'TCPDataLen';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Data';
      ListColumn.Width := 100;
      ListColumn.Tag := 100;
    end;
    UDPDATA_FIELD: begin
      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'UDPDataLen';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;

      ListColumn := ListView.Columns.Add;
      ListColumn.Caption := 'Data';
      ListColumn.Width := 50;
      ListColumn.Tag := 50;
    end;
  end;
end;

procedure LoadListColumnWidth(Form: TForm; IniFileName: String);
var
  i, j, ColumnWidth: Integer;
  IniFile: TIniFile;
  ListView: TListView;
  ListColumn: TListColumn;
begin
  IniFile := TIniFile.Create(IniFileName);
  for i := 0 to Form.ComponentCount - 1 do
  begin
    if not (Form.Components[i] is TListView) then continue;
    ListView := Form.Components[i] as TListView;
    for j := 0 to ListView.Columns.Count - 1 do
    begin
      ColumnWidth := IniFile.ReadInteger(ListView.Name, 'Width' + IntToStr(j), -1);
      if ColumnWidth <> -1 then
      begin
        ListColumn := ListView.Columns.Items[j];
        ListColumn.Width := ColumnWidth;
      end;
    end;
  end;
  IniFile.Free;
end;

procedure SaveListColumnWidth(Form: TForm; IniFileName: String);
var
  i, j, ColumnWidth: Integer;
  IniFile: TIniFile;
  ListView: TListView;
  ListColumn: TListColumn;
begin
  IniFile := TIniFile.Create(IniFileName);
  try
    for i := 0 to Form.ComponentCount - 1 do
    begin
      if not (Form.Components[i] is TListView) then continue;
      ListView := Form.Components[i] as TListView;
      for j := 0 to ListView.Columns.Count - 1 do
      begin
        ListColumn := ListView.Columns.Items[j];
        ColumnWidth := ListColumn.Width;
        IniFile.WriteInteger(ListView.Name, 'Width' + IntToStr(j), ColumnWidth);
      end;
    end;
  finally
    IniFile.Free;
  end;
end;

procedure ShowColumn(ListView: TListView; StartIndex: Integer; EndIndex: Integer);
var
  i: Integer;
  ListColumn: TListColumn;
begin
  for i := StartIndex to EndIndex do
  begin
    ListColumn := ListView.Columns.Items[i];
    ListColumn.Width := ListColumn.Tag;
  end;
end;

procedure HideColumn(ListView: TListView; StartIndex: Integer; EndIndex: Integer);
var
  i: Integer;
  ListColumn: TListColumn;
begin
  for i := StartIndex to EndIndex do
  begin
    ListColumn := ListView.Columns.Items[i];
    ListColumn.Tag := ListColumn.Width;
    ListColumn.Width := 0;
  end;
end;

// procedure AddPKTHdr(ListItem: TListItem; PKTHdr: PPCAP_PKTHDR); // gilgil temp 2008.01.28
procedure AddPKTHdr(ListItem: TListItem; SnoopMemoryNode: PSnoopMemoryNode);
var
  PKTHdr: PPCAP_PKTHDR;
  Hour: LongWord;
  Min: LongWord;
  Sec: LongWord;
  TimeStr: String;
begin
  PKTHdr := @SnoopMemoryNode.PKTHdr;

  Sec := PKTHdr.ts.tv_sec;
  Sec := Sec mod 86400; // Remove day
  Hour := Sec div 3600;
  Sec := Sec mod 3600;
  Min := Sec div 60;
  Sec := Sec mod 60;

  TimeStr := TimeStr + Format('%2d:%2d:%2d:%6d', [Hour, Min, Sec, PKTHdr.ts.tv_usec]);
  TimeStr := StringReplace(TimeStr, ' ', '0', [rfReplaceAll]);

  ListItem.Caption := IntToStr(SnoopMemoryNode^.Index);
  ListItem.SubItems.Add(TimeStr);
  ListItem.SubItems.Add(IntToStr(PKTHdr.caplen));
  ListItem.SubItems.Add(IntToStr(PKTHdr.len));
end;

procedure AddETH(ListItem: TListItem; ETHHdr: PETH_HDR);
begin
  ListItem.SubItems.Add(snoopMac2Str(ETHHdr^.Destination));
  ListItem.SubItems.Add(snoopMac2Str(ETHHdr^.Source));
  ListItem.SubItems.Add(IntToHex(ntohs(ETHHdr^.Protocol), 4));
end;

procedure AddIP(ListItem: TListItem; IPHdr: PIP_HDR);
var
  ChecksumStr: String;
  OldChecksum: UINT16;
  NewChecksum: UINT16;
begin
  ListItem.SubItems.Add(IntToHex(SmallInt(IPHdr.Verlen), 2));
  ListItem.SubItems.Add(IntToStr(IPHdr.Service));
  ListItem.SubItems.Add(IntToStr(ntohs(IPHdr.Len)));
  ListItem.SubItems.Add(IntToStr(ntohs(IPHdr.Ident)));
  ListItem.SubItems.Add(IntToHex(ntohs(IPHdr.FlagOff), 2));
  ListItem.SubItems.Add(IntToStr(IPHdr.TimeLive));
  ListItem.SubItems.Add(IntToHex(IPHdr.Protocol, 2));

  ChecksumStr := IntToHex(ntohs(IPHdr.Checksum), 4);
  OldChecksum := ntohs(IPHdr.Checksum);
  NewChecksum := snoopIPChecksum(IPHdr);
  if OldChecksum <> NewChecksum then
    ChecksumStr := ChecksumStr + '(' + IntToHex(NewChecksum, 4) + ')';
  ListItem.SubItems.Add(ChecksumStr);

  ListItem.SubItems.Add(snoopIP2Str(ntohl(IPHdr.Source)));
  ListItem.SubItems.Add(snoopIP2Str(ntohl(IPHdr.Destination)));
end;

procedure AddARP(ListItem: TListItem; ARPHdr: PARP_HDR);
begin
  ListItem.SubItems.Add(IntToStr(ntohs(ARPHdr.HardwareType)));
  ListItem.SubItems.Add(IntToStr(ntohs(ARPHdr.ProtocolType)));
  ListItem.SubItems.Add(IntToStr(ARPHdr.HLen));
  ListItem.SubItems.Add(IntToStr(ARPHdr.PLen));
  ListItem.SubItems.Add(IntToStr(ntohs(ARPHdr.Operation)));
  ListItem.SubItems.Add(snoopMac2Str(ARPHdr.SenderHA));
  ListItem.SubItems.Add(snoopIP2Str(ntohl(ARPHdr.SenderIP)));
  ListItem.SubItems.Add(snoopMac2Str(ARPHdr.TargetHA));
  ListItem.SubItems.Add(snoopIP2Str(ntohl(ARPHdr.TargetIP)));
end;

procedure AddICMP(ListItem: TListItem; ICMPHdr: PICMP_HDR);
begin
  ListItem.SubItems.Add(IntToStr(ICMPHdr.Type_));
  ListItem.SubItems.Add(IntToStr(ICMPHdr.Code));
  ListItem.SubItems.Add(IntToHex(ntohs(ICMPHdr^.Checksum), 4));
end;

function GetTCPOptionValue(TCPHdr: PTCP_HDR): String;
var
  sRes: String;
  TCPOption: PChar;
  TCPOptionLen: Integer;
  SnoopTCPOption: TSnoopTCPOption;
  nRes: Integer;
  Value8: UINT8;
  Value16: UINT16;
begin
  sRes := '';
  if snoopIsTCPOption(TCPHdr, @TCPOption, @TCPOptionLen) then
  begin
    while true do
    begin
      nRes := snoopGetTCPOption(TCPOption, TCPOptionLen, @SnoopTCPOption);
      if nRes = 0 then break;

      if sRes <> '' then sRes := sRes + '/';
      sRes := sRes + SnoopTCPOption.Meaning;
      Value8 := PUINT8(@SnoopTCPOption.Value)^;
      Value16 := ntohs(PUINT16(@SnoopTCPOption.Value)^);
      case SnoopTCPOption.Kind of
        2: begin // Maximum Segment Size
          sRes := sRes + '(' + IntToStr(Value16) + ')';
        end;
        3: begin // WSOPT - Window Scale
          sRes := sRes + '(multiply by ' + IntToStr(1 shl Value8) + ')';
        end;
      end;

      inc(TCPOption, nRes);
      dec(TCPOptionLen, nRes);
    end;
  end;
  Result := sRes;
end;

procedure AddTCP(ListItem: TListItem; IPHdr: PIP_HDR; TCPHdr: PTCP_HDR);
var
  ChecksumStr: String;
  OldChecksum: UINT16;
  NewChecksum: UINT16;
begin
  ListItem.SubItems.Add(IntToStr(ntohs(TCPHdr.Source)));
  ListItem.SubItems.Add(IntToStr(ntohs(TCPHdr.Destination)));
  ListItem.SubItems.Add(IntToHex(DWORD(ntohl(TCPHdr.Seq)), 4));
  ListItem.SubItems.Add(IntToHex(DWORD(ntohl(TCPHdr.Ack)), 4));
  ListItem.SubItems.Add(IntToHex(TCPHdr.Off_Rsvd, 2));
  ListItem.SubItems.Add(IntToHex(TCPHdr.Rsvd_Flags, 2) + Rsvd_Flags2Str(TCPHdr.Rsvd_Flags));
  ListItem.SubItems.Add(IntToStr(ntohs(TCPHdr.Window)));

  ChecksumStr := IntToHex(ntohs(TCPHdr.Checksum), 4);
  OldChecksum := ntohs(TCPHdr.Checksum);
  NewChecksum := snoopTCPChecksum(IPHdr, TCPHdr);
  if OldChecksum <> NewChecksum then
    ChecksumStr := ChecksumStr + '(' + IntToHex(NewChecksum, 4) + ')';
  ListItem.SubItems.Add(ChecksumStr);

  ListItem.SubItems.Add(IntToStr(ntohs(TCPHdr.UrgPoint)));
  ListItem.SubItems.Add(GetTCPOptionValue(TCPHdr));
end;

procedure AddUDP(ListItem: TListItem; IPHdr: PIP_HDR; UDPHdr: PUDP_HDR);
var
  ChecksumStr: String;
  OldChecksum: UINT16;
  NewChecksum: UINT16;
begin
  ListItem.SubItems.Add(IntToStr(ntohs(UDPHdr.Source)));
  ListItem.SubItems.Add(IntToStr(ntohs(UDPHdr.Destination)));
  ListItem.SubItems.Add(IntToStr(ntohs(UDPHdr.Len)));

  ChecksumStr := IntToHex(ntohs(UDPHdr.Checksum), 4);
  OldChecksum := ntohs(UDPHdr.Checksum);
  NewChecksum := snoopUDPChecksum(IPHdr, UDPHdr);
  if OldChecksum <> NewChecksum then
    ChecksumStr := ChecksumStr + '(' + IntToHex(NewChecksum, 4) + ')';
  ListItem.SubItems.Add(ChecksumStr);

  //ListItem.SubItems.Add(IntToHex(ntohs(UDPHdr.Checksum), 4));
end;

procedure AddTCPData(ListItem: TListItem; TCPData: PChar; TCPDataLen: Integer; Offset: Integer);
var
  s: String;
begin
  ListItem.SubItems.Add(IntToStr(TCPDataLen));
  if TCPDataLen >= Offset then
  begin
    SetLength(s, TCPDataLen - Offset);
    StrMove(PChar(s), TCPData + Offset, TCPDataLen - Offset);
    ListItem.SubItems.Add(s);
  end;
end;

procedure AddUDPData(ListItem: TListItem; UDPData: PChar; UDPDataLen: Integer; Offset: Integer);
var
  s: String;
begin
  ListItem.SubItems.Add(IntToStr(UDPDataLen));
  if UDPDataLen >= Offset then
  begin
    SetLength(s, UDPDataLen - Offset);
    StrMove(PChar(s), UDPData + Offset, UDPDataLen - Offset);
    ListItem.SubItems.Add(s);
  end;
end;

function Rsvd_Flags2Str(Flag: UCHAR): String;
begin
  Result := '';
  if (Flag and $20) <> 0 then Result := Result + ' URG';
  if (Flag and $10) <> 0  then Result := Result + ' ACK';
  if (Flag and $08) <> 0  then Result := Result + ' PSH';
  if (Flag and $04) <> 0  then Result := Result + ' RST';
  if (Flag and $02) <> 0  then Result := Result + ' SYN';
  if (Flag and $01) <> 0  then Result := Result + ' FIN';
end;

end.
