unit FormCapturing;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Snoop, SnoopMemory, VDTrace, Globals;

type
  TCapturingForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    lblETH: TLabel;
    lblIP: TLabel;
    lblARP: TLabel;
    lblICMP: TLabel;
    lblTCP: TLabel;
    lblUDP: TLabel;
    lblTCPData: TLabel;
    lblUDPData: TLabel;
    Bevel1: TBevel;
    btnClose: TButton;
    tmrView: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCloseClick(Sender: TObject);
    procedure tmrViewTimer(Sender: TObject);
  private
    { Private declarations }
    ETHCount: Integer;
    IPCount: Integer;
    ARPCount: Integer;
    ICMPCount: Integer;
    TCPCount: Integer;
    UDPCount: Integer;
    TCPDataCount: Integer;
    UDPDataCount: Integer;
  public
    { Public declarations }
    procedure Initialize;
    procedure View;
    procedure Process(PKTHdr: PPCAP_PKTHDR; ETHHdr: PETH_HDR);
  end;

var
  CapturingForm: TCapturingForm;

implementation

uses FormMain;

{$R *.DFM}

procedure TCapturingForm.Initialize;
begin
  ETHCount := 0;
  IPCount := 0;
  ARPCount := 0;
  ICMPCount := 0;
  TCPCount := 0;
  UDPCount := 0;
  TCPDataCount := 0;
  UDPDataCount := 0;
end;

procedure TCapturingForm.View;
begin
  lblETH.Caption := IntToStr(ETHCount);
  lblIP.Caption := IntToStr(IPCount);
  lblARP.Caption := IntToStr(ARPCount);
  lblICMP.Caption := IntToStr(ICMPCount);
  lblTCP.Caption := IntToStr(TCPCount);
  lblUDP.Caption := IntToStr(UDPCount);
  lblTCPData.Caption := IntToStr(TCPDataCount);
  lblUDPData.Caption := IntToStr(UDPDataCount);
end;

procedure TCapturingForm.Process(PKTHdr: PPCAP_PKTHDR; ETHHdr: PETH_HDR);
var
  IPHdr: PIP_HDR;
  TCPHdr: PTCP_HDR;
  UDPHdr: PUDP_HDR;
begin
  inc(ETHCount);
  if snoopIsIP(ETHHdr, @IPHdr) then
  begin
    inc(IPCount);
    if snoopIsTCP(IPHdr, @TCPHdr) then
    begin
      inc(TCPCount);
      if snoopIsTCPData(IPHdr, TCPHdr) then
        inc(TCPDataCount);
    end else if snoopIsUDP(IPHdr, @UDPHdr) then
    begin
      inc(UDPCount);
      if snoopIsUDPData(IPHdr, UDPHdr) then
        inc(UDPDataCount);
    end else if snoopIsICMP(IPHdr) then
      inc(ICMPCount);
  end else if snoopIsARP(ETHHdr) then
  begin
    inc(ARPCount);
  end;
end;

procedure TCapturingForm.FormCreate(Sender: TObject);
begin
//
end;

procedure TCapturingForm.FormShow(Sender: TObject);
begin
  View;
  tmrView.Enabled := true;
end;

procedure TCapturingForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  tmrView.Enabled := false;
end;

procedure TCapturingForm.btnCloseClick(Sender: TObject);
begin
  MainForm.ActionClose.Execute;
end;

procedure TCapturingForm.tmrViewTimer(Sender: TObject);
begin
  View;
end;

end.
