unit FormOpen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls,  Buttons, Globals;

type
  TOpenForm = class(TForm)
    pcOpen: TPageControl;
    tsAdapter: TTabSheet;
    tsRemote: TTabSheet;
    tsFile: TTabSheet;
    cbxAdapter: TComboBox;
    lblFilter: TLabel;
    lblReadTimeout: TLabel;
    lblSnapLen: TLabel;
    edReadTimeout: TEdit;
    edSnapLen: TEdit;
    chkThreadSafe: TCheckBox;
    lblHost: TLabel;
    lblUserName: TLabel;
    lblPassword: TLabel;
    edHost: TEdit;
    edUserName: TEdit;
    edPassword: TEdit;
    edFileName: TEdit;
    sbtFileName: TSpeedButton;
    btnOK: TButton;
    btnCancel: TButton;
    odFile: TOpenDialog;
    cbxFilter: TComboBox;
    lblFlags: TLabel;
    edFlags: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbtFileNameClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure pcOpenChange(Sender: TObject);
  private
    { Private declarations }
    procedure SetControl;
  public
    { Public declarations }
  end;

var
  OpenForm: TOpenForm;

implementation

uses FormOption, FormMain;

{$R *.DFM}

procedure TOpenForm.SetControl;
var
  Index: Integer;
begin
  Index := pcOpen.ActivePageIndex;
  // if file load, ReadTimeout, SnapLen, ThreadSafe do not need.
  edReadTimeout.Enabled := Index <> 2;
  edSnapLen.Enabled := Index <> 2;
  chkThreadSafe.Enabled := Index <> 2;
end;

procedure TOpenForm.FormCreate(Sender: TObject);
begin
//
end;

procedure TOpenForm.FormShow(Sender: TObject);
begin
  Global.Load;
  // Open Type
  pcOpen.ActivePageIndex := Global.OpenType;
  // Adapter
  cbxAdapter.Items := MainForm.Snoop1.AdapterDescriptions;
  cbxAdapter.ItemIndex := Global.AdapterIndex;
  if cbxAdapter.ItemIndex = -1 then
    cbxAdapter.ItemIndex := 0;
  // Remote
  edHost.Text := Global.Host;
  edUserName.Text := Global.UserName;
  edPassword.Text := Global.Password;
  // File
  edFileName.Text := Global.FileName;
  // Snoop Property
  cbxFilter.Text := Global.Filter;
  edFlags.Text := IntToStr(Global.Flags);
  edReadTimeout.Text := IntToStr(Global.ReadTimeout);
  edSnapLen.Text := IntToStr(Global.SnapLen);
  chkThreadSafe.Checked := Global.ThreadSafe;
  // FilterList
  cbxFilter.Items := Global.FilterList;

  SetControl;
end;

procedure TOpenForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//
end;

procedure TOpenForm.sbtFileNameClick(Sender: TObject);
begin
  if odFile.Execute then
    edFileName.Text := odFile.FileName;
end;

procedure TOpenForm.btnOKClick(Sender: TObject);
var
  i: Integer;
begin
  // Open Type
  Global.OpenType := pcOpen.ActivePageIndex;
  // Adapter Capture
  Global.AdapterIndex := cbxAdapter.ItemIndex;
  // Remote Capture
  Global.Host := edHost.Text;
  Global.UserName := edUserName.Text;
  Global.Password := edPassword.Text;
  // File Capture
  Global.FileName := edFileName.Text;
  // Snoop Property
  Global.Filter := cbxFilter.Text;
  Global.Flags := StrToInt(edFlags.Text);
  Global.ReadTimeout := StrToInt(edReadTimeout.Text);
  Global.SnapLen := StrToInt(edSnapLen.Text);
  Global.ThreadSafe := chkThreadSafe.Checked;
  // FilterList
  i := Global.FilterList.IndexOf(cbxFilter.Text);
  if i <> -1 then
    Global.FilterList.Delete(i);
  Global.FilterList.Insert(0, cbxFilter.Text);

  Global.Save;
end;

procedure TOpenForm.pcOpenChange(Sender: TObject);
begin
  SetControl;
end;

end.

