unit FormPacketField;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls;

type
  TPacketFieldForm = class(TForm)
    btnOK: TButton;
    btnCancel: TButton;
    pnlMain: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
    CheckBoxes: array [0 .. 255] of TCheckBox;
    procedure FreeAllCheckBox;
  public
    { Public declarations }
    ListView: TListView;
  end;

var
  PacketFieldForm: TPacketFieldForm;

implementation

{$R *.DFM}

procedure TPacketFieldForm.FreeAllCheckBox;
var
  i: Integer;
  CheckBox: TCheckBox;
begin
  i := 0;
  while i < ComponentCount do
  begin
    if Components[i] is TCheckBox then
    begin
      CheckBox := Components[i] as TCheckBox;
      CheckBox.Free;
    end else
      inc(i);
  end;
end;

procedure TPacketFieldForm.FormCreate(Sender: TObject);
begin
  pnlMain.BevelOuter := bvNone;
end;

procedure TPacketFieldForm.FormShow(Sender: TObject);
var
  i, Top: Integer;
  ListColumn: TListColumn;
begin
  FreeAllCheckBox;
  if ListView = nil then exit;
  Top := 0;
  for i := 0 to ListView.Columns.Count - 1 do
  begin
    ListColumn := ListView.Columns[i];
    CheckBoxes[i] := TCheckBox.Create(Self);
    CheckBoxes[i].Parent := pnlMain;
    CheckBoxes[i].Left := 8;
    Top := i * Font.Size * 2;
    CheckBoxes[i].Top := Top;
    CheckBoxes[i].Caption := ListColumn.Caption;
    CheckBoxes[i].Checked := ListColumn.Width <> 0;
    CheckBoxes[i].Tag := ListColumn.Width; // for backup of ListColumn Width
  end;
  if Top <> 0 then
  begin
    pnlMain.Height := Top + Font.Size * 3;
    ClientHeight := pnlMain.Height + 16;
  end;
  Caption := 'Packet Field (' + ListView.Hint + ')';
end;

procedure TPacketFieldForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//
end;

procedure TPacketFieldForm.btnOKClick(Sender: TObject);
var
  i: Integer;
  ListColumn: TListColumn;
begin
  ListView.Visible := false;
  for i := 0 to ListView.Columns.Count - 1 do
  begin
    ListColumn := ListView.Columns[i];
    ListColumn.Width := CheckBoxes[i].Tag;
    if not CheckBoxes[i].Checked then
      ListColumn.Width := 0;
    // if show packet field
    if CheckBoxes[i].Checked and (ListColumn.Width = 0) then
      ListColumn.Width := ListColumn.Tag;
  end;
  ListView.Visible := true;
end;

end.
