unit FormOption;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Globals;

type
  TOptionForm = class(TForm)
    cbxAdapter: TComboBox;
    lblFilter: TLabel;
    lblReadTimeOut: TLabel;
    lblSnapLen: TLabel;
    edReadTimeOut: TEdit;
    edSnapLen: TEdit;
    chkThreadSafe: TCheckBox;
    lblAdapter: TLabel;
    edFilter: TEdit;
    btnOK: TButton;
    btnCancel: TButton;
    lblMaxBytes: TLabel;
    edMaxBytes: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  OptionForm: TOptionForm;

implementation

uses FormMain;

{$R *.DFM}

procedure TOptionForm.FormCreate(Sender: TObject);
begin
  cbxAdapter.Items := MainForm.SnoopStatistics1.AdapterDescriptions;
end;

procedure TOptionForm.FormShow(Sender: TObject);
begin
  Global.Load;
  // WinPcap
  cbxAdapter.ItemIndex := Global.AdapterIndex;
  if cbxAdapter.ItemIndex = -1 then
    cbxAdapter.ItemIndex := 0;
  edFilter.Text := Global.Filter;
  edReadTimeOut.Text := IntToStr(Global.ReadTimeOut);
  edSnapLen.Text := IntToStr(Global.SnapLen);
  chkThreadSafe.Checked := Global.ThreadSafe;
  // Statistics
  edMaxBytes.Text := IntToStr(Global.MaxBytes);
end;

procedure TOptionForm.btnOKClick(Sender: TObject);
begin
  // WinPcap
  Global.AdapterIndex := cbxAdapter.ItemIndex;
  Global.Filter := edFilter.Text;
  Global.ReadTimeOut := StrToInt(edReadTimeOut.Text);
  Global.SnapLen := StrToInt(edSnapLen.Text);
  Global.ThreadSafe := chkThreadSafe.Checked;
  // Statistics
  Global.MaxBytes := StrToInt(edMaxBytes.Text);

  Global.Save;

end;

end.
