unit FormMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WinSock, StdCtrls, Snoop, ExtCtrls, Globals;

type
  TMainForm = class(TForm)
    mmResult: TMemo;
    SnoopTCP1: TSnoopTCP;
    pnlTop: TPanel;
    btnOpen: TButton;
    btnClose: TButton;
    btnClear: TButton;
    tmrWriteMsg: TTimer;
    SnoopMyNetwork1: TSnoopMyNetwork;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOpenClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure tmrWriteMsgTimer(Sender: TObject);
    procedure SnoopTCP1CaptureTCP(Sender: TObject;
      PKTHdr: PPCAP_PKTHDR; ETHHdr: PETH_HDR;
      IPHdr: PIP_HDR; TCPHdr: PTCP_HDR);
  private
    { Private declarations }
    WriteMessage: String;
    procedure SetControl;
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses FormOpen;

{$R *.DFM}

procedure TMainForm.SetControl;
var
  Active: Boolean;
begin
  Active := SnoopTCP1.Active;
  btnOpen.Enabled := not Active;
  btnClose.Enabled := Active;
  tmrWriteMsg.Enabled := Active;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  mmResult.Align := alClient;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  Global.Load;
  Left := Global.MainLeft;
  Top := Global.MainTop;
  Width := Global.MainWidth;
  Height := Global.MainHeight;
  SetControl;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Global.MainLeft := Left;
  Global.MainTop := Top;
  Global.MainWidth := Width;
  Global.MainHeight := Height;
  Global.Save;
end;

procedure TMainForm.btnOpenClick(Sender: TObject);
begin
  if OpenForm.ShowModal <> mrOk then exit;
  SnoopTCP1.AdapterIndex := Global.AdapterIndex;
  SnoopTCP1.Filter := Global.Filter;
  SnoopTCP1.Flags := Global.Flags;
  SnoopTCP1.ReadTimeOut := Global.ReadTimeOut;
  SnoopTCP1.SnapLen := Global.SnapLen;
  SnoopTCP1.ThreadSafe := Global.ThreadSafe;
  SnoopTCP1.Open;
  if not SnoopTCP1.Active then
  begin
    ShowMessage(SnoopTCP1.Error);
    exit;
  end;
  SnoopMyNetwork1.AdapterIndex := Global.AdapterIndex;
  WriteMessage := '';
  SetControl;
end;

procedure TMainForm.btnCloseClick(Sender: TObject);
begin
  SnoopTCP1.Close;
  tmrWriteMsgTimer(nil);
  SetControl;
end;

procedure TMainForm.btnClearClick(Sender: TObject);
begin
  mmResult.Lines.Clear;
end;


procedure TMainForm.tmrWriteMsgTimer(Sender: TObject);
begin
  if WriteMessage <> '' then
  begin
    mmResult.Lines.Add(WriteMessage);
    WriteMessage := '';
  end;
end;

procedure TMainForm.SnoopTCP1CaptureTCP(Sender: TObject;
  PKTHdr: PPCAP_PKTHDR; ETHHdr: PETH_HDR;
  IPHdr: PIP_HDR; TCPHdr: PTCP_HDR);
var
  Msg: String;
begin
  if IPHdr^.TimeLive = 44 then exit;

  snoopSendTCPBlock(SnoopTCP1.Pcap, @SnoopMyNetwork1.Mac,
    ETHHdr, IPHdr, TCPHdr);
  Msg :=
    Format('TCPBlock %s(%u)->%s(%u)', [
    PChar(snoopIP2Str(ntohl(IPHdr^.Source))),
    ntohs(TCPHdr^.Source),
    PChar(snoopIP2Str(ntohl(IPHdr^.Destination))),
    ntohs(TCPHdr^.Destination)]);
  if WriteMessage = '' then
    WriteMessage := Msg
  else
    WriteMessage := WriteMessage + #13#10 + Msg;
end;

end.
