unit FormOpen;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Buttons, Globals;

type
  TOpenForm = class(TForm)
    lblFilter: TLabel;
    lblReadTimeOut: TLabel;
    lblSnapLen: TLabel;
    edReadTimeOut: TEdit;
    edSnapLen: TEdit;
    chkThreadSafe: TCheckBox;
    btnOK: TButton;
    btnCancel: TButton;
    odFile: TOpenDialog;
    cbxAdapter: TComboBox;
    lblAdapter: TLabel;
    edFilter: TEdit;
    lblFlags: TLabel;
    edFlags: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxAdapterChange(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure pcOpenChange(Sender: TObject);
  private
    { Private declarations }
    procedure SetControl;
  public
    { Public declarations }
  end;

var
  OpenForm: TOpenForm;

implementation

uses FormMain;

{$R *.DFM}

procedure TOpenForm.SetControl;
begin
  btnOK.Enabled := cbxAdapter.ItemIndex <> -1;
end;

procedure TOpenForm.FormCreate(Sender: TObject);
begin
  cbxAdapter.Items := MainForm.SnoopTCP1.AdapterDescriptions;
end;

procedure TOpenForm.FormShow(Sender: TObject);
begin
  Global.Load;
  cbxAdapter.ItemIndex := Global.AdapterIndex;
  edFilter.Text := Global.Filter;
  edFlags.Text := IntToStr(Global.Flags);
  edReadTimeOut.Text := IntToStr(Global.ReadTimeOut);
  edSnapLen.Text := IntToStr(Global.SnapLen);
  chkThreadSafe.Checked := Global.ThreadSafe;
  SetControl;
end;

procedure TOpenForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
//
end;

procedure TOpenForm.cbxAdapterChange(Sender: TObject);
begin
  SetControl;
end;

procedure TOpenForm.btnOKClick(Sender: TObject);
begin
  Global.AdapterIndex := cbxAdapter.ItemIndex;
  Global.Filter := edFilter.Text;
  Global.Flags := StrtoInt(edFlags.Text);  
  Global.ReadTimeOut := StrToInt(edReadTimeOut.Text);
  Global.SnapLen := StrToInt(edSnapLen.Text);
  Global.ThreadSafe := chkThreadSafe.Checked;
  Global.Save;
end;

procedure TOpenForm.pcOpenChange(Sender: TObject);
begin
  SetControl;
end;

end.

