// Console.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Snoop.h"

class CMySnoop : public CSnoopTCPData
{
public:
	int m_nCount;
	CMySnoop() { m_nCount = 0; }
	static bool IsNormalChar(char ch);
	virtual void OnCaptureTCPData(
		void        *pSender,
		PCAP_PKTHDR *pPKTHdr,
		ETH_HDR     *pETHHdr,
		IP_HDR      *pIPHdr,
		TCP_HDR     *pTCPHdr,
		char        *pTCPData,
		int          nTCPDataLen);
};

bool CMySnoop::IsNormalChar(char ch)
{
	if (ch >= 32 && ch <= 192) return true;
	return false;
}

void CMySnoop::OnCaptureTCPData(
		void        *pSender,
		PCAP_PKTHDR *pPKTHdr,
		ETH_HDR     *pETHHdr,
		IP_HDR      *pIPHdr,
		TCP_HDR     *pTCPHdr,
		char        *pTCPData,
		int          nTCPDataLen)
{
	int i, nIndex;
	char *pBuffer = (char*)malloc(nTCPDataLen + 1);

	nIndex = 0;
    for (i = 0; i < nTCPDataLen; i++)
	{
		if (IsNormalChar(*pTCPData))
			pBuffer[nIndex++] = *pTCPData;
		pTCPData++;
	}
	pBuffer[nIndex] = '\0';
	printf("%s\n", pBuffer);
	m_nCount++;
	free(pBuffer);
}

int GetAdapterIndex(CCustomSnoop *pSnoop)
{
	int i, nRes;

	for (i = 0; i < pSnoop->m_strAdapterDescriptions.m_nCount; i++)
	{
		string strAdapterName = pSnoop->m_strAdapterDescriptions.GetAt(i);
		printf("%d: %s\n", i, (char*)strAdapterName);
	}
	printf("select device : ");
	scanf("%d", &nRes);
	return nRes;
}

#define DETECT_TIME 10000
int main(int argc, char* argv[])
{
	CMySnoop *pMySnoop = new CMySnoop;
	pMySnoop->SetAdapterIndex(GetAdapterIndex(pMySnoop));
	pMySnoop->Open();
	if (!pMySnoop->m_bActive)
	{
		printf("%s\n", (char*)pMySnoop->m_strError);
		return -1;
	}
	Sleep(DETECT_TIME);
	printf("%d pakcet(s) captured during %d millisecond", pMySnoop->m_nCount, DETECT_TIME);
	GTRACE("[Console.cpp] main bef delete");
	delete pMySnoop;
	GTRACE("[Console.cpp] main aft delete");
	return 0;
}
